<?PHP
/**
* @copyright Copyright (C) 2008 Zundan. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* PhppyaNG! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/


// Motor de la Pasarela de Pago para ser usada por 
// la seccion de usuario

// Hay que asegurarse que el usuario no ha modificado el codigo fuente
// del HTML

global $plc;
$plc = getparameter("plc");
global $imp;
$imp = getparameter("imp");

echo "$plc<br>";
// 1.- Obtener el codigo de sufijo perteneciente a este campus, 
// centro o departamento

pasarela2_dump_sufix_by_desc ($plc, 1, 0, $arr_suflist, $arr_sufnum);

// Tiene que haber un sufijo, sino hay, habra que enviar un error.

if ($arr_sufnum != 1){

	$output = "<h3>" .  UIMESG_WARNING_SUFIXNOTEXISTS . "</h3><br/>" . UIMESG_COMMON_OR . "\n";
	$output .= "<h3>" . UIMESG_WARNING_SUFIXREPEATED . "</h3>\n";
	$output .= "<h3>" . UIMESG_WARNING_NOTDEFINED_CONTACT_ADMIN . "</h3>\n";
	return ($output);

}

// 2.- Verificamos que el importe sea positivo

if (! empty($imp) ){ 

	$imp = strtr ($imp, "," , ".");

}


if ( (! is_numeric($imp)) OR ($imp < PASARELAPAGO_MINIMUM_PAYMENT) ){

	$output = "<h3>" .  UIMESG_WARNING_AMOUNT_LESS_MINIMUM . "</h3>\n";
	$output .= "<h3>" . UIMESG_WARNING_AMOUNTSHOULDPOSITIVE . "</h3>\n";
	return ($output);

}

// 3. El importe debe ser convertido a centeuros
$imp = $imp * 100;

// 4.- Obtenemos el timestamp del servidor, el cual genera 10 digitos
$referencia = time();

// le añadimos el 11 digito, que sera aleatorio
$referencia .= mt_rand (0,9);
$referencia = substr ($referencia, 0, 11);

// 5.- Calcular el digito de control
$dcontrol = pasarela_calcularDCC57 (PASARELAPAGO_EMISOR, $arr_suflist[0]['sufijo'],  $referencia, PASARELAPAGO_IDENTIFICACION, $imp);

// 6.- Una vez obtenido el digito de control ($dcontrol), se construye los datos en estructura XML:
// Nota: basandose en el libro 57, el campo 'tipo' contiene el mismo valor que el campo 'sufijo'.
// en el libro 60, el tipo seria un tipo  de tributo, y no tendria que ser igual que el sufijo.

$datos =  pasarela_prepararXMLinicial (PASARELAPAGO_FORMATO, PASARELAPAGO_CPR, PASARELAPAGO_EMISOR, 
					$arr_suflist[0]['sufijo'], $referencia, $dcontrol, PASARELAPAGO_IDENTIFICACION, 
					$imp, $arr_suflist[0]['sufijo'], $ldapuser, $ldapuserdni);

// 7.- Se prepara el conjunto de los datos, con la cabecera, que despues se enviaran al servidor de la pasarela:

// Oharra: nahiz eta konexioa https motakoa izan, array hau osatzean 
//         http motako protokoloa erabili behar da.
//         Gero, konexioa egiterako orduan https erabiliko da.
// Nota: aunque la conexion sera HTTPS, a la hora de construir el conjunto de los datos, hay que especificar
//		el protocolo HTTP.

$context_options = array (
	'http' => array (
		'method' => 'POST',
		'header'=> "Content-type: application/x-www-form-urlencoded\r\n"
			. "Content-Length: " . strlen("xmlRPC=" . $datos) . "\r\n",
		'content' =>  "xmlRPC=" . $datos
		)
	);


// 8.- CONEXION con la pasarela via XMLRPC

$context = stream_context_create ($context_options);

// Conectarse con el servidor de prueba, via HTTPS
// Konektatu probako zerbitzariarekin, HTTPS bidez

$fp = fopen (PASARELAPAGO_URLPASARELAPAGO, 'r', false, $context);

$output = "<h3>" . UIMESG_PASARELA_PAYBRIDGE . "</h3>\n<h3>";
$output .= UIMESG_WARNING_NOTCONECTED . "</h3>\n<h3>" . UIMESG_WARNING_NOTDEFINED_CONTACT_ADMIN . "</h3>";

if (!$fp) die ($output);

// 9.- Obtener respuesta del servidor de la pasarela de pagos
//$respuesta = stream_get_contents($fp);

if (function_exists ('stream_get_contents')){

	$respuesta = stream_get_contents ($fp);

} else {
	// La funcion stream_get_contents solo esta a partir de PHP 5,
	// por lo que si es una version inferior, esta funcion NO EXISTIRA
	// Luego usamos la siguiente alternativa ;)

	$respuesta = '';

	while (!feof($fp)) {

		$respuesta .= fread($fp, 8192);

	}
}



// 10.- Analizamos la respuesta obtenida desde la Pasarela de Pagos

// La variable $pagoID es global, y se le asignara un valor
// dentro de la funcion

$pagoID = "";
		


if (pasarela_obten_identificador_pago ($respuesta)){

	$URLretorno = PASARELAPAGO_URLRETORNO ;

	$URL_redirection = PASARELAPAGO_URLREDIRECCION;
	$URL_language = PASARELAPAGO_IDIOMA;

	if ( (strcmp($_COOKIE["language"], "eu") == 0) || (strcmp($_COOKIE["language"], "eu-es") == 0)){
		$URL_redirection = PASARELAPAGO_URLREDIRECCION_EU . "?p12iIdioma=eu ";
		$URL_language = PASARELAPAGO_IDIOMA_EU;
	}

	$paginaHTML = pasarela_preparar_datos_redireccion ($URL_redirection, $pagoID, $URL_language , PASARELAPAGO_MODOPAGO, PASARELAPAGO_IDSESSION, $URLretorno);

	// Ahora hay que preparar los datos para crear un nuevo registro
	// en la tabla 'pasarela_pago".
	$aux = strtok($plc, DESCSUBSEPARATOR);

	$aux2 = strtok(DESCSUBSEPARATOR);

	pasarela2_add_paycorrection ($usid.NAMESEPARATOR.$aux.SUBNAMESEPARATOR.$aux2.NAMESEPARATOR.BALANCESHORT, PASARELAPAGO_FORMATO, $referencia.$dcontrol, PASARELAPAGO_CPR, PASARELAPAGO_EMISOR, $arr_suflist[0]['sufijo'], $pagoID, PASARELAPAGO_IDENTIFICACION, $arr_suflist[0]['sufijo'], $plc, PASAPAGO_STATUS_STARTED, $imp);

	echo 	 $paginaHTML;

} else {

	include("../styles/". DEFAULT_STYLE ."/user_warning_pasarela_error.php");
}


?>

